// $Id$
(function ($) {

Drupal.drd = Drupal.drd || {};
Drupal.settings.drd = Drupal.settings.drd || {};

Drupal.behaviors.drd = {
  attach: function (context) {
    Drupal.settings.drd.cacheMode = 2;
    Drupal.settings.drd.forceMode = false;
    Drupal.settings.drd.AjaxNo = 0;
    Drupal.settings.drd.DebugID = 0;
    Drupal.settings.drd.collectArray = new Object();
    Drupal.drd.initCollectArray();
    Drupal.drd.initWidgets();
  }
};

Drupal.drd.initCollectArray = function () {
  Drupal.settings.drd.collectArray['drd_op'] = new Array();
  Drupal.settings.drd.collectArray['drd_id'] = new Array();
  Drupal.settings.drd.collectArray['drd_domain'] = new Array();
  Drupal.settings.drd.collectArray['drd_params'] = new Array();
  Drupal.settings.drd.collectArray['drd_fnc'] = new Array();
}

Drupal.drd.id = function (element) {
  var id = $(element).attr('id');
  if (id === undefined) {
    id = 0;
  }
  else {
    id = id.substr(2);
  }
  return id;
}

Drupal.drd.updateDetail = function (element) {
  var server;
  if (element === undefined) {
    server = $('#drd-dashboard #servers .server.selected');
  }
  else {
    server = $(element).parents('.server');
    $('#drd-dashboard #servers .server').removeClass('selected');
    $(server).addClass('selected');
  }
  var id = Drupal.drd.id(server);
  $('#server-domain-details .server-domain-detail').hide();
  $('#server-domain-details #id'+id+' .server-domain-detail').show();
  $('#server-domain-details .server').removeClass('selected');
  $('#server-domain-details #id'+id+' .server-domain-detail').parent().addClass('selected');
  $('#server-details .server').removeClass('selected');
  $('#server-details #id'+id+' .server-detail').parent().addClass('selected');
}

Drupal.drd.update = function (element) {
  var server = $(element).parents('.server');
  var domain = $(element).parents('.domain');
  var id = Drupal.drd.id(server);
  var domain_id = 0;
  if (domain !== undefined) {
    domain_id = Drupal.drd.id(domain);
  }
  $(element).addClass('updating');
  if ($(server).hasClass('selected')) {
    Drupal.drd.updateDetail();
  }
  if ($(element).hasClass('edit')) {
    Drupal.drd.Interact('EditServer', id);
  }
  if ($(element).hasClass('delete')) {
    if (confirm('Are you sure?')) {
      Drupal.drd.Interact('DeleteServer', id);
    }
    $(element).removeClass('updating');
  }
  if ($(element).hasClass('info')) {
    if (domain_id > 0) {
      Drupal.drd.Interact('DomainInfo', id, domain_id);
    }
    else {
      Drupal.drd.Interact('ServerInfo', id);
    }
  }
  if ($(element).hasClass('domains')) {
    Drupal.drd.Interact('ServerDomains', id);
  }
  if ($(element).hasClass('php-error-log')) {
    Drupal.drd.Interact('ServerPHPErrorLog', id);
  }
  if ($(element).hasClass('svn-status')) {
    Drupal.drd.Interact('ServerSVNStatus', id);
  }
  if ($(element).hasClass('svn-update')) {
    Drupal.drd.Interact('ServerSVNUpdate', id);
  }
  if ($(element).hasClass('flush-cache')) {
    Drupal.drd.Interact('DomainFlushCache', id, domain_id);
  }
  if ($(element).hasClass('run-cron')) {
    Drupal.drd.Interact('DomainRunCron', id, domain_id);
  }
  if ($(element).hasClass('list-updates')) {
    Drupal.drd.Interact('DomainListUpdates', id, domain_id);
  }
  if ($(element).hasClass('run-update')) {
    Drupal.drd.Interact('DomainRunUpdate', id, domain_id);
  }
  if ($(element).hasClass('switch-maintenance')) {
    Drupal.drd.Interact('DomainSwitchMaintenance', id, domain_id);
  }
  if ($(element).hasClass('update-translation')) {
    Drupal.drd.Interact('DomainUpdateTranslation', id, domain_id);
  }
  if ($(element).hasClass('server-info')) {
    Drupal.drd.show('server-info', id);
  }
  if ($(element).hasClass('server-message-list')) {
    Drupal.drd.show('server-message-list', id);
  }
  if ($(element).hasClass('server-php-error-log')) {
    Drupal.drd.show('server-php-error-log', id);
  }
  if ($(element).hasClass('server-svn-status')) {
    Drupal.drd.show('server-svn-status', id);
  }
  if ($(element).hasClass('server-svn-update')) {
    Drupal.drd.show('server-svn-update', id);
  }
}

Drupal.drd.show = function (selector, id) {
  $('.server-info-box').hide();
  $('#drd-dashboard #server-details #id'+id+' .server-info-box.'+selector).show();
  $('#drd-dashboard #servers #id'+id+' .info-toolbar .'+selector).removeClass('updating');
}

Drupal.drd.initWidgets = function () {
  $('#drd-dashboard #servers .server-show-detail:not(.drd-processed)')
    .addClass('drd-processed')
    .addClass('pointer')
    .click(function () {
      Drupal.drd.updateDetail(this);
    })
  $('#drd-dashboard #servers .server:not(.drd-processed)')
    .addClass('drd-processed')
    .each(function () {
      Drupal.drd.update($('.server-toolbar .info', this));
      Drupal.drd.update($('.server-toolbar .domains', this));
      Drupal.drd.update($('.server-toolbar .svn-status', this));
      Drupal.drd.update($('.server-toolbar .list-updates', this));
    })
  $('#drd-dashboard .drd-run-once')
    .removeClass('drd-run-once')
    .each(function () {
      if (Drupal.settings.drd.cacheMode == 0) {
        Drupal.drd.update(this);
      }
    })
  $('#drd-dashboard #servers .server-toolbar div.ui-icon:not(.drd-processed)')
    .addClass('drd-processed')
    .addClass('pointer')
    .click(function () {
      Drupal.drd.update(this);
    })
  $('#drd-dashboard #server-domain-details .domain-toolbar div.ui-icon:not(.drd-processed)')
    .addClass('drd-processed')
    .addClass('pointer')
    .click(function () {
      Drupal.drd.update(this);
    })
    .each(function () {
      if ($(this).hasClass('info') || $(this).hasClass('list-updates')) {
        Drupal.drd.update(this);
      }
    })
  $('#drd-dashboard .toolbar div.ui-icon:not(.drd-processed)')
    .addClass('drd-processed')
    .addClass('pointer')
    .click(function () {
      var mode = Drupal.drd.buttonMode(this);
      var toolbar = $(this).parents('.toolbar');
      if ($(toolbar).hasClass('all-server-toolbar')) {
        $('#drd-dashboard #servers .server').each(function () {
          var id = Drupal.drd.id(this);
          $('#drd-dashboard #servers #id'+id+'.server .server-toolbar .'+mode).trigger('click');
        })
      }
      else if ($(toolbar).hasClass('all-server-all-domains-toolbar')) {
        $('#drd-dashboard #servers .server').each(function () {
          var id = Drupal.drd.id(this);
          Drupal.drd.invokeUpdateAllDomains(id, mode);
        })
      }
      else if ($(toolbar).hasClass('all-domains-toolbar')) {
        var server = $(this).parents('.server');
        var id = Drupal.drd.id(server);
        Drupal.drd.invokeUpdateAllDomains(id, mode);
      }
      else if ($(toolbar).hasClass('general-toolbar')) {
        if (mode == 'new') {
          Drupal.drd.Interact('NewServer');
        }
        else if (mode == 'flush-cache') {
          Drupal.drd.Interact('FlushDRDCache');
        }
      }
    })
  $('#drd-dashboard div.ui-icon.refresh:not(.drd-processed)')
    .addClass('drd-processed')
    .addClass('pointer')
    .click(function () {
      Drupal.drd.update(this);
    })
  $('#drd-dashboard div.ui-icon.close:not(.drd-processed)')
    .addClass('drd-processed')
    .addClass('pointer')
    .click(function () {
      $(this).parent().hide();
    })
  $('#drd-dashboard div.ui-icon.delete:not(.drd-processed)')
    .addClass('drd-processed')
    .addClass('pointer')
    .click(function () {
      var list = $(this).parent();
      $('.content', list).html('');
    })
  $('#drd-dashboard div.ui-icon.toggle-update-list:not(.drd-processed)')
    .addClass('drd-processed')
    .addClass('pointer')
    .click(function () {
      var list = $(this).parent();
      $('tr.ok', list).toggle();
    })
  $('#drd-dashboard #server-domain-details .domain .domain-toggle:not(.drd-processed)')
    .addClass('drd-processed')
    .addClass('pointer')
    .click(function () {
      var domain = $('.domain-details', $(this).parents('.domain'));
      $(domain).toggle();
    })
  $('#drd-dashboard #server-domain-details .domain .domain-alias-toggle:not(.drd-processed)')
    .addClass('drd-processed')
    .addClass('pointer')
    .click(function () {
      var aliases = $('.domain-aliases', $(this).parents('.domain'));
      $(aliases).toggle();
    })
  $('#drd-dashboard #server-edit .save-button:not(.drd-processed)')
    .addClass('drd-processed')
    .addClass('pointer')
    .click(function () {
      var id = $('#drd-dashboard #server-edit input[name="id"]')[0].value;
      var values = new Object();
      values['disabled'] = $('#drd-dashboard #server-edit #edit-disabled')[0].checked;
      values['weight'] = $('#drd-dashboard #server-edit #edit-weight')[0].value;
      values['url'] = $('#drd-dashboard #server-edit #edit-url')[0].value;
      values['user'] = $('#drd-dashboard #server-edit #edit-user')[0].value;
      values['password'] = $('#drd-dashboard #server-edit #edit-password')[0].value;
      values['svn_enabled'] = $('#drd-dashboard #server-edit #edit-svn-enabled')[0].checked;
      values['svn_user'] = $('#drd-dashboard #server-edit #edit-svn-user')[0].value;
      values['svn_password'] = $('#drd-dashboard #server-edit #edit-svn-password')[0].value;
      values['svn_force_external'] = $('#drd-dashboard #server-edit #edit-svn-force-external')[0].checked;
      values['disabled_domains'] = $('#drd-dashboard #server-edit #edit-disabled-domains')[0].value;
      $('#drd-dashboard #server-edit').hide();
      Drupal.drd.Interact('SaveServer', id, '', values);
    })
  $('#drd-dashboard #server-edit .cancel-button:not(.drd-processed)')
    .addClass('drd-processed')
    .addClass('pointer')
    .click(function () {
      $('#drd-dashboard #server-edit').hide();
    })
  Drupal.drd.sendCollected();
}

Drupal.drd.buttonMode = function (element) {
  var mode = $(element).attr('class');
  mode = mode.replace(/drd-processed/g,'');
  mode = mode.replace(/icon-inline/g,'');
  mode = mode.replace(/pointer/g,'');
  mode = mode.replace(/ui-.*[ ]?/g,'');
  mode = mode.replace(/ /g,'');
  return mode;
}

Drupal.drd.checkServerAlert = function (selector) {
  var server = $(selector);
  var id = Drupal.drd.id(server);
  $('.server-alert-warning .toggle-alert', server).hide();
  $('.server-alert-error .toggle-alert', server).hide();
  $('#server-domain-details #id'+id+'.server .domain-alert-warning .toggle-alert').each(function() {
    if ($(this).data('drdWarning')) {
      $('.server-alert-warning .toggle-alert', server).show();
    }
  });
  $('#server-domain-details #id'+id+'.server .domain-alert-error .toggle-alert').each(function() {
    if ($(this).data('drdError')) {
      $('.server-alert-error .toggle-alert', server).show();
    }
  });
}

Drupal.drd.invokeUpdateAllDomains = function (id, mode) {
  $('#drd-dashboard #server-domain-details #id'+id+'.server .domain-toolbar .'+mode)
    .addClass('updating')
    .trigger('click')
}

Drupal.drd.completeAjax = function () {
  Drupal.settings.drd.AjaxNo--;
  if (Drupal.settings.drd.AjaxNo == 0) {
    $('#drd-status').hide();
  }
}

Drupal.drd.execute = function (answer) {
  if (typeof answer == 'string') {
    if (answer.length > 0) {
      try {
        var x = $.parseJSON(answer);
      }
      catch (e) {
        //This shouldn't happen but there is nothing we can do about it here
        //Enable the following line for debugging only
        //alert(e);
      }
    }
  }
  else if (typeof answer == 'object') {
    var x = answer;
  }
  if (x !== undefined) {
    for (var i = 0; i < x.length; i++) {
      switch (x[i].cmd) {
        case 'modContent':
          $(x[i].selector).html(x[i].content);
          break;
        case 'replaceContent':
          $(x[i].selector).replaceWith(x[i].content);
          break;
        case 'prependContent':
          $(x[i].selector).prepend(x[i].content);
          break;
        case 'appendContent':
          $(x[i].selector).append(x[i].content);
          break;
        case 'removeContent':
          $(x[i].selector).remove();
          break;
        case 'modStyle':
          $(x[i].selector).css(x[i].property, x[i].value);
          break;
        case 'addClass':
          $(x[i].selector).addClass(x[i].value);
          if (x[i].markSelector) {
            $(x[i].selector).data('usedSelector', x[i].selector);
          }
          break;
        case 'removeClass':
          $(x[i].selector).removeClass(x[i].value);
          break;
        case 'setData':
          $(x[i].selector).data(x[i].name, x[i].value);
          break;
        case 'setAttribute':
          $(x[i].selector)[0].setAttribute(x[i].name, x[i].value);
          break;
        case 'show':
          $(x[i].selector).show();
          break;
        case 'hide':
          $(x[i].selector).hide();
          break;
        case 'updateSelected':
          if ($(x[i].selector).parents('.server').hasClass('selected')) {
            Drupal.drd.updateDetail();
          }
          break;
        case 'checkServerAlert':
          Drupal.drd.checkServerAlert(x[i].selector);
          break;
        case 'EditServer':
          $('#drd-dashboard #server-edit input[name="id"]')[0].value = x[i].id;
          $('#drd-dashboard #server-edit #edit-weight')[0].value = x[i].weight;
          $('#drd-dashboard #server-edit #edit-disabled')[0].checked = x[i].disabled;
          $('#drd-dashboard #server-edit #edit-url')[0].value = x[i].url;
          $('#drd-dashboard #server-edit #edit-user')[0].value = x[i].user;
          $('#drd-dashboard #server-edit #edit-password')[0].value = x[i].password;
          $('#drd-dashboard #server-edit #edit-svn-enabled')[0].checked = x[i].svn_enabled;
          $('#drd-dashboard #server-edit #edit-svn-user')[0].value = x[i].svn_user;
          $('#drd-dashboard #server-edit #edit-svn-password')[0].value = x[i].svn_password;
          $('#drd-dashboard #server-edit #edit-svn-force-external')[0].checked = x[i].svn_force_external;
          $('#drd-dashboard #server-edit #edit-disabled-domains')[0].value = x[i].disabled_domains;
          $('#drd-dashboard #server-edit').show();
          break;
        case 'interactNoCache':
          Drupal.drd.Interact(x[i].op, x[i].id, x[i].domain);
          break;
        case 'turnOnCacheMode':
          Drupal.settings.drd.cacheMode = 2;
          break;
        case 'turnOffCacheMode':
          Drupal.settings.drd.cacheMode--;
          break;
        case 'error':
          $('#drd-dashboard #error-messages .content')
            .prepend('<div class="msg">'+x[i].msg+'</div>')
          $('#drd-dashboard #error-messages')
            .show()
          break;
        case 'reload':
          location.reload(true);
          return;
        case 'alert':
          alert(x[i].content);
          break;
      }
    }
  }
  Drupal.settings.drd.ajaxActive = false;
  Drupal.drd.initWidgets();
}

Drupal.drd.sendCollected = function() {
  if (Drupal.settings.drd.collectArray['drd_id'].length == 0) {
    Drupal.settings.drd.cacheMode = 0;
    return;
  }
  if (Drupal.settings.drd.cacheMode > 0) {
    var _op = Drupal.settings.drd.collectArray['drd_op'];
    var _id = Drupal.settings.drd.collectArray['drd_id'];
    var _do = Drupal.settings.drd.collectArray['drd_domain'];
    var _pa = Drupal.settings.drd.collectArray['drd_params'];
    Drupal.drd.initCollectArray();
    Drupal.settings.drd.forceMode = true;
    Drupal.drd.Interact(_op, _id, _do, _pa);
  }
  else {
    // Remove one element which is not required
    Drupal.settings.drd.collectArray['drd_params'].shift();
    Drupal.drd.Interact(
      Drupal.settings.drd.collectArray['drd_op'].shift(),
      Drupal.settings.drd.collectArray['drd_id'].shift(),
      Drupal.settings.drd.collectArray['drd_domain'].shift()
    );
  }
}

Drupal.drd.Interact = function (_op, _id, _domain, _params) {
  if (!Drupal.settings.drd.forceMode && ((Drupal.settings.drd.cacheMode > 0) || Drupal.settings.drd.ajaxActive)) {
    if ((_domain !== undefined) && (_domain > 0)) {
      _params = $('#drd-dashboard #server-domain-details #id'+_id+' #id'+_domain+' .domain-url .plain-url').html();
    }
    Drupal.settings.drd.collectArray['drd_op'].push(_op);
    Drupal.settings.drd.collectArray['drd_id'].push(_id);
    Drupal.settings.drd.collectArray['drd_domain'].push(_domain);
    Drupal.settings.drd.collectArray['drd_params'].push(_params);
    return;
  }
  Drupal.settings.drd.forceMode = false;
  Drupal.settings.drd.ajaxActive = true;
  var _url = '';
  if (_id === undefined) {
    _id = 0;
  }
  var info = _op + ': Server ' + _id;
  if (_domain !== undefined) {
    info = info + ' Domain ' + _domain;
    if (typeof _domain == 'object') {
      _op = _op.join(',');
      _id = _id.join(',');
      _domain = _domain.join(',');
      _url = _params.join(',');
      _params = new Object();
      info = 'Multi-Collect-Mode';
    }
    else if (_domain > 0) {
      _url = $('#drd-dashboard #server-domain-details #id'+_id+' #id'+_domain+' .domain-url .plain-url').html();
    }
  }
  else {
    _domain = '';
  }
  _fnc = function (answer) {Drupal.drd.execute(answer)};
  if (_params === undefined) {
    _params = new Object();
  }
  Drupal.settings.drd.AjaxNo++;
  Drupal.settings.drd.DebugID++;
  _params['drd_op'] = _op;
  _params['drd_id'] = _id;
  _params['drd_domain'] = _domain;
  _params['drd_url'] = _url;
  _params['drd_debug_id'] = Drupal.settings.drd.DebugID;
  $('#drd-status .msg').html(info);
  $('#drd-status').show();
  $.ajax({
    url: Drupal.settings.drd.url,
    async: true,
    global: false,
    type: 'POST',
    data: _params,
    dataType: 'html',
    complete: function () {
      Drupal.drd.completeAjax();
    },
    success: _fnc,
    error: function (XMLHttpRequest, textStatus, errorThrown) {
      Drupal.settings.drd.ajaxActive = false;
      alert(Drupal.ajaxError(XMLHttpRequest, _op));
    }
  });
}

})(jQuery);
